﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: False
#End Region

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
    Dim Chooser As ContentChooser
	Private frontCamera As Boolean = False	
    Dim Accelerometer As PhoneAccelerometer
	Dim Portrait As Boolean
	Dim InpTyp As SLInpTypeConst
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim IME As IME
	Dim camEx As CameraExClass
	Dim whlTimeHM As ClsWheel	
	Dim iScore As Int
	Dim iQOrder As Int
	Dim DataTable As List	
	Dim iAnswer As Int
	Dim sHelp As String
	Dim iShowTime As Int
	Dim iAddQuestion As Int
	Dim Filename As String
	Dim iPreviewCount As Int
	Private VisitPhotos As List
	
	Private lblSave As Label
	Private lblHelp As Label
	Private lblQuestion As Label
	Private txtAnswer As EditText
	Private pnlAnswer As Panel
	Private lblCamera As Label
	Private lblGallery As Label
	Private lblComment As Label
	Private pnlCamera As Panel
	Private lblAnswer As Label
	Private lblScore As Label
	Private scrollQuestion As ScrollView
	Dim clvAnswers As aCustomListView	
	Private lblTake As Label
	Private lblAccept As Label
	Private lblReject As Label
	Private lblNext As Label
	Private lblDelete As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then 
		Common.RestoreGlobals
        Chooser.Initialize("Chooser")		
	End If

	IME.Initialize("IME")
	If Not(Common.mySQL.IsInitialized) Then
		StartActivity(Main)
		Activity.Finish
	End If	
	
	Activity.LoadLayout("frmTest")
	
	lblQuestion.RemoveView
	scrollQuestion.Panel.AddView(lblQuestion,0,0,lblQuestion.Width,lblQuestion.Height*2)
	Common.ScaleAll(Activity)
	
	whlTimeHM.Initialize(Me, Activity, "Select Time", 2, Null, 30 * Common.ScaleH, 1, True)
	
	ShowCurrentQuestion
End Sub

Sub Activity_Resume
    Accelerometer.StartListening("Accelerometer")
End Sub

Sub Activity_Pause(UserClosed As Boolean)
	ReleaseCamera
    Accelerometer.StopListening
End Sub

Sub Accelerometer_AccelerometerChanged (X As Float, Y As Float, Z As Float)
    Portrait = X < Y
End Sub

Sub ShowCurrentQuestion
	Dim Cols() As String
	Dim iPhotoCount As Int
	
	Cols = Common.Questions.Get(Common.iCurrentQuestion - 1)
	
	iScore = 0
	iAnswer = -1
	
	sHelp = Cols(2)
	iQOrder = Cols(3)
	iShowTime = Cols(6)
	iAddQuestion = Cols(7)

	iPhotoCount = Common.mySQL.ExecQuerySingleResult("SELECT COUNT(*) FROM files WHERE " & _
	"venue_id = " & Common.iCurrentVenueID & " AND section_id = " & Common.iCurrentSectionID & _
	" AND qorder = " & iQOrder & " AND yearmonth = '" & Common.iCurrentYearMonth & "'" & _
	" AND additional = " & iAddQuestion)
	
	lblQuestion.Text = "Question " & Common.iCurrentQuestion & " of " & Common.iLastQuestion & " - Photos " & iPhotoCount & CRLF & Cols(1)
	If iShowTime <> 0 Then
		ShowAnswer
		If txtAnswer.Text = "" Then
			If iShowTime == 1 Then
				whlTimeHM.Show2("TimeHM","")
			Else
				whlTimeHM.Show2("TimeHM","02:15")
			End If
		Else	
			If iShowTime == 1 Then
				whlTimeHM.Show2("TimeHM",txtAnswer.Text)
			Else
				whlTimeHM.Show2("TimeHM",NumberFormat(txtAnswer.Text / 60,2,0) & ":" & NumberFormat(txtAnswer.Text Mod 60,2,0) )	
			End If			
		End If 
	Else
		GetAnswers
		ShowAnswer
	End If
End Sub

Sub TimeHM_Closed(Cancelled As Boolean, TimeTicks As String)
	If Cancelled = False Then
		txtAnswer.Text = TimeTicks.SubString2(0,5)
		If iShowTime == 2 Then
			txtAnswer.Text = NumberFormat(TimeTicks.SubString2(0,2) * 60 + TimeTicks.SubString2(3,5),0,0)
		End If
		lblAnswer.Text = txtAnswer.Text
		iScore = 10
		lblScore.Text = iScore
		pnlAnswer.Color = Colors.Green	
		SetAnswer				
	End If
End Sub

Sub GetAnswers
	Dim sAns As String
	Dim Cols() As String
	Dim iLen As Int
	
	'Creating the list view of all active Answers
	clvAnswers.Clear

	If iAddQuestion == 0 Then
		DataTable = Common.ExecuteMemoryTable(Common.mySQL, "SELECT score, option_txt FROM testanswers WHERE section_id = " & Common.iCurrentSectionID & " AND qorder = " & iQOrder & " ORDER By score DESC", Null, 0)
		For i = 0 To DataTable.Size - 1
			Cols = DataTable.Get(i)
			sAns = Cols(1)
			If sAns.Length > 110 Then
				For iLen = 110 To 1 Step -1
					If sAns.IndexOf2(" ",iLen) <> -1 Then
						sAns = sAns.SubString2(0,sAns.IndexOf2(" ",iLen)) & " ..."
						Exit
					End If
				Next
			End If
			clvAnswers.Add(CreateListItem(sAns, clvAnswers.AsView.Width, 90 * Common.ScaleV * Common.ScaleD), 90 * Common.ScaleV * Common.ScaleD, i)
		Next
	End If	
End Sub

Sub CreateListItem(Text As String, Width As Int, Height As Int) As Panel
	Dim p As Panel
	p.Initialize("")
	p.Color = Colors.Cyan
	Dim lblListItem As Label
	lblListItem.Initialize("Label")
	lblListItem.Text = Text
	lblListItem.Color = Colors.Transparent
	lblListItem.TextColor = Colors.Black
	lblListItem.TextSize = 24 * Common.ScaleT
    lblListItem.Gravity = Gravity.LEFT
	p.AddView(lblListItem,5, 0, Width-10, Height)
	Return p
End Sub

Sub Label_Click
	Dim Cols() As String
	Dim iIndex As Int

	iAnswer = clvAnswers.GetItemFromView(Sender)
		
	If lblAnswer.Text <> "" Then
		If Common.MsgboxShow("Change Current Answer","Confirmation","Continue","","Cancel") = DialogResponse.NEGATIVE Then Return
	End If
	
	Cols = DataTable.Get(iAnswer)
	iScore = Cols(0)
	iIndex = Cols(1).IndexOf("-")
	If iIndex == -1 Then
		txtAnswer.Text = "" 
	Else
		If iIndex+2 > Cols(1).Length Then
			txtAnswer.Text = "" 
		Else
			txtAnswer.Text = Cols(1).SubString(iIndex+2)
		End If
	End If
	lblAnswer.Text = txtAnswer.Text
	If iAddQuestion == 0 Then lblScore.Text = iScore
	lblComment.RequestFocus
	If txtAnswer.Text <> "" Then
		 SetAnswer
	Else
		lblComment_Click
	End If
End Sub

Sub ShowAnswer
	If Common.mySQL.ExecQuerySingleResult("SELECT COUNT(*) FROM scores " & _
	" WHERE tester_id = " & Common.iCurrentTesterID & " AND qorder = " & iQOrder & _
	" AND section_id = " & Common.iCurrentSectionID & " AND venue_id = " & Common.iCurrentVenueID & _
	" AND yearmonth = " & Common.iCurrentYearMonth & " AND addquestion = " & iAddQuestion) <> 0 Then	
		iScore = Common.mySQL.ExecQuerySingleResult("SELECT score FROM scores " & _
		" WHERE tester_id = " & Common.iCurrentTesterID & " AND qorder = " & iQOrder & _
		" AND section_id = " & Common.iCurrentSectionID & " AND venue_id = " & Common.iCurrentVenueID & _
		" AND yearmonth = " & Common.iCurrentYearMonth & " AND addquestion = " & iAddQuestion)

		txtAnswer.Text = Common.mySQL.ExecQuerySingleResult("SELECT comment FROM scores " & _
		" WHERE tester_id = " & Common.iCurrentTesterID & " AND qorder = " & iQOrder & _
		" AND section_id = " & Common.iCurrentSectionID & " AND venue_id = " & Common.iCurrentVenueID & _
		" AND yearmonth = " & Common.iCurrentYearMonth & " AND addquestion = " & iAddQuestion)
		pnlAnswer.Color = Colors.Green	
	Else
		iScore = 0
		txtAnswer.Text = ""
		pnlAnswer.Color = Colors.Cyan	
	End If
	lblAnswer.Text = txtAnswer.Text
	If iAddQuestion == 0 Then lblScore.Text = iScore
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Then	
		If pnlCamera.Visible = True Then
			ReleaseCamera
		Else
			StartActivity(frmQuestion)
			Activity.Finish
		End If
		Return True
	Else
		Return False
	End If
End Sub

Sub lblHelp_Click
	Dim sMessage As String
	
	If iAddQuestion == 0 Then
		Msgbox(sHelp,"Marking Criteria")
		sMessage = Common.mySQL.ExecQuerySingleResult("SELECT guidance FROM testguidance WHERE section_id = " & Common.iCurrentSectionID & " AND qorder = " & iQOrder)
		Msgbox(sMessage, "Guidance Notes")
	Else
		Msgbox("Enter your own comments", "Guidance Notes")
	End If
End Sub

Sub lblSave_Click
	If txtAnswer.Text.IndexOf("..") <> -1 Then
		Msgbox("Please delete the dots(...) and then include your personal comments","59club")
		Return
	End If
	
	If txtAnswer.Text <> "" Then SetAnswer

	StartActivity(frmQuestion)
	Activity.Finish
End Sub

Sub txtAnswer_EnterPressed
	If txtAnswer.Text.IndexOf("..") <> -1 Then
		Msgbox("Please delete the dots(...) and then include your personal comments","59club")
		Return
	End If
		
	If txtAnswer.Text <> "" Then
		SetAnswer
	Else
		txtAnswer.Visible = False
		lblAnswer.Visible = True
		IME.HideKeyboard
	End If
End Sub

Sub SetAnswer
	txtAnswer.Visible = False
	lblAnswer.Visible = True
	IME.HideKeyboard
	lblAnswer.Text = txtAnswer.Text
	pnlAnswer.Color = Colors.Green
			
	If txtAnswer.Text.IndexOf("..") <> -1 Then
		Msgbox("Please delete the dots(...) and then include your personal comments","59club")
	Else
		DateTime.DateFormat = "yyyy/MM/dd"
		DateTime.TimeFormat = "HH:mm:ss"
		If Common.mySQL.ExecQuerySingleResult("SELECT COUNT(*) FROM scores " & _
		" WHERE tester_id = " & Common.iCurrentTesterID & " AND qorder = " & iQOrder & _
		" AND section_id = " & Common.iCurrentSectionID & " AND venue_id = " & Common.iCurrentVenueID & _
		" AND yearmonth = " & Common.iCurrentYearMonth & " AND addquestion = " & iAddQuestion) = 0 Then
	    	Common.mySQL.ExecNonQuery("INSERT INTO scores VALUES(" & Common.iCurrentTesterID & ", " & iQOrder & _
			", " & Common.iCurrentSectionID & ", " & Common.iCurrentVenueID & ", " & Common.iCurrentYearMonth & _
			", " & iScore & ", '" & txtAnswer.Text.Trim.Replace("'","''") & "', '" & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & "', " & iAddQuestion & ")")
		Else
			Common.mySQL.ExecNonQuery("UPDATE scores SET score = " & iScore & ", comment = '" & txtAnswer.Text.Trim.Replace("'","''") & "'" & _
			" WHERE tester_id = " & Common.iCurrentTesterID & " AND qorder = " & iQOrder & _
			" AND section_id = " & Common.iCurrentSectionID & " AND venue_id = " & Common.iCurrentVenueID & _
			" AND yearmonth = " & Common.iCurrentYearMonth & " AND addquestion = " & iAddQuestion)		
		End If	
			
		Common.bUpdated = True
	End If
End Sub

Sub lblComment_Click
	If iShowTime <> 0 Then
		If iShowTime == 1 Then
			whlTimeHM.Show2("TimeHM",txtAnswer.Text)
		Else
			whlTimeHM.Show2("TimeHM",NumberFormat(txtAnswer.Text / 60,2,0) & ":" & NumberFormat(txtAnswer.Text Mod 60,2,0) )	
		End If			
	Else
		If lblAnswer.Text == "" And iAddQuestion == 0 Then
			Common.MessageShow("Select one of the multi-choice answers first", True)
		Else
			InpTyp.SetInputType(txtAnswer,Array As Int(InpTyp.TYPE_CLASS_TEXT,InpTyp.TYPE_TEXT_FLAG_CAP_SENTENCES))			
			lblAnswer.Visible = False
			txtAnswer.Visible = True
			txtAnswer.RequestFocus
			If txtAnswer.Text <> "" Then txtAnswer.Text = txtAnswer.Text & " "
			txtAnswer.SelectionStart = txtAnswer.Text.Length
			IME.ShowKeyboard(txtAnswer)		
		End If
	End If
End Sub

Sub lblGallery_Click	
	If txtAnswer.Visible = True Then 
		txtAnswer_EnterPressed
	Else
		If iAddQuestion == 0 And Common.iUploadPhotos = 1 Then		
    		Chooser.Show("image/*", "Choose image")
		Else
			Common.MessageShow("Photos not required",True)
		End If
	End If
End Sub

Sub Chooser_Result (Success As Boolean, FromDir As String, FromFileName As String)
	Filename = Common.iCurrentYearMonth & Common.iCurrentVenueID & Common.iCurrentTesterID & Common.iCurrentSectionID & iQOrder & DateTime.now & ".jpg"

	If Success Then
		Dim sImage As OutputStream
		Dim PictureBitmap As Bitmap
		Dim PreviewBitmap As Bitmap
		Dim ExtendedBitmap As BitmapExtended
		Dim exifdata1 As ExifData
				
		PreviewBitmap.Initialize(FromDir, FromFileName)
		PictureBitmap = LoadBitmapSample(FromDir,FromFileName,800,800)

		Try
			ExtendedBitmap.Initialize("extended")
			exifdata1.Initialize(FromDir,FromFileName)
			Log(exifdata1.getAttribute(exifdata1.TAG_ORIENTATION))
			Select Case exifdata1.getAttribute(exifdata1.TAG_ORIENTATION)
				Case exifdata1.ORIENTATION_ROTATE_180 '3
					PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,180)
				Case exifdata1.ORIENTATION_ROTATE_90 '6		
					PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,90)
				Case exifdata1.ORIENTATION_ROTATE_270 '8
					PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,270)
				Case Else
					PreviewBitmap = PictureBitmap
			End Select
		Catch
		  	Common.MessageShow("Photo Rotation Error",True)
		End Try		

		sImage = File.OpenOutput(Common.sTestPhotosPath, Filename, False)
		PreviewBitmap.WriteToStream(sImage, 50, "JPEG")
					
		Common.MessageShow("Picture saved, Size: " & File.Size(Common.sTestPhotosPath, Filename), True)		

		SetPhoto	
	Else
        Common.MessageShow("No image selected", True)
    End If
End Sub

Private Sub InitializeCamera
	camEx.Initialize(pnlCamera, frontCamera, Me, "CameraTester")
	frontCamera = camEx.Front
End Sub

Sub lblCamera_Click
	If txtAnswer.Visible = True Then 
		txtAnswer_EnterPressed
	Else
		If iAddQuestion == 0 And Common.iUploadPhotos = 1 Then		
			pnlCamera.Visible = True
			pnlCamera.BringToFront
			lblTake.Visible = True
			lblTake.BringToFront
			lblAccept.BringToFront
			lblReject.BringToFront	
			InitializeCamera
		Else
			Common.MessageShow("Photos not required",True)
		End If		
	End If
End Sub

Sub CameraTester_Ready (Success As Boolean)
	Dim lSizes() As CameraSize
	Dim iMean As Int
	
	If Success Then
		camEx.SetJpegQuality(70)
		lSizes = camEx.GetSupportedPicturesSizes
		iMean = Floor(lSizes.Length / 1.5)
		camEx.SetPictureSize(lSizes(iMean).Width, lSizes(iMean).Height)
		camEx.CommitParameters
		camEx.StartPreview
		Log(camEx.GetPreviewSize)
	Else
		Common.MessageShow("Cannot open camera.", True)
	End If
End Sub

Sub CameraTester_PictureTaken (Data() As Byte)
	Filename = Common.iCurrentYearMonth & Common.iCurrentVenueID & Common.iCurrentTesterID & Common.iCurrentSectionID & iQOrder & DateTime.now & ".jpg"

	camEx.SavePictureToFile(Data, Common.sTestPhotosPath, Filename)
	
	Common.MessageShow("Picture saved." & CRLF  & "Size: " & File.Size(Common.sTestPhotosPath, Filename), True)
	ReleaseCamera
	Common.ForceGallery(Filename)
	PreviewPicture
	lblAccept.Visible = True
	lblReject.Visible = True
End Sub

Sub ReleaseCamera
	If camEx.IsInitialized Then camEx.Release
	pnlCamera.Visible = False
	lblTake.Visible = False
	lblAccept.Visible = False
	lblReject.Visible = False
	lblNext.Visible = False
	lblDelete.Visible = False
	pnlCamera.Visible = False
	ShowCurrentQuestion
End Sub

Sub PreviewPicture
	Dim PictureBitmap As Bitmap
	Dim PreviewBitmap As Bitmap
	Dim ExtendedBitmap As BitmapExtended
	Dim exifdata1 As ExifData
  	PictureBitmap = LoadBitmapSample(Common.sTestPhotosPath,Filename,800,800)

	Try
		ExtendedBitmap.Initialize("extended")
		exifdata1.Initialize(Common.sTestPhotosPath,Filename)
		Select Case exifdata1.getAttribute(exifdata1.TAG_ORIENTATION)
			Case exifdata1.ORIENTATION_ROTATE_180 '3
				PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,180)
			Case exifdata1.ORIENTATION_ROTATE_90 '6		
				PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,90)
			Case exifdata1.ORIENTATION_ROTATE_270 '8
				PreviewBitmap = ExtendedBitmap.rotateBitmap(PictureBitmap,270)
			Case Else
				PreviewBitmap = PictureBitmap
		End Select
	Catch
	  	Common.MessageShow("Photo Rotation Error",True)
	End Try

	If Portrait Then
      Dim out As OutputStream
      out = File.OpenOutput(Common.sTestPhotosPath, Filename, False)
      PreviewBitmap.WriteToStream(out, 50, "JPEG")
      out.Close
	End If
	
	pnlCamera.SetBackgroundImage(PreviewBitmap)
	pnlCamera.Visible = True
End Sub

Sub lblAnswer_Click
	lblComment_Click
End Sub

Sub SetPhoto
	DateTime.DateFormat = "yyyy/MM/dd"
	DateTime.TimeFormat = "HH:mm:ss"
	If Common.mySQL.ExecQuerySingleResult("SELECT COUNT(*) FROM files WHERE filename = '" & Filename & "'") = 0 Then
    	Common.mySQL.ExecNonQuery("INSERT INTO files VALUES('" & Filename & "', " & Common.iCurrentVenueID & _
		", " & Common.iCurrentSectionID & ", " & iQOrder & ", " & Common.iCurrentYearMonth & _
		", '" & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & "', " & iAddQuestion & ")")
	Else
		Common.mySQL.ExecNonQuery("UPDATE files SET section_id = " & Common.iCurrentSectionID & ", qorder = " & iQOrder & _
		", additional = " & iAddQuestion & " WHERE filename = '" & Filename & "'")		
	End If	
	
	Common.bUpdated = True
	ShowCurrentQuestion
End Sub

Sub lblTake_Click
	camEx.TakePicture	
	lblTake.Visible = False
	pnlCamera.Visible = False
End Sub

Sub pnlCamera_Touch (Action As Int, X As Float, Y As Float)
	Return
End Sub

Sub txtAnswer_TextChanged (Old As String, New As String)
	If txtAnswer.Text = CRLF Then
		 txtAnswer.Text = ""
	End If
End Sub

Sub lblAccept_Click
	Common.MessageShow("Picture accepted.", True)
	lblAccept.Visible = False
	lblReject.Visible = False
	pnlCamera.Visible = False
	SetPhoto
End Sub

Sub lblReject_Click
	File.Delete(Common.sTestPhotosPath, Filename)
	Common.MessageShow("Picture removed.", True)
	lblAccept.Visible = False
	lblReject.Visible = False
	pnlCamera.Visible = False
End Sub

Sub lblQuestion_Click
	VisitPhotos = Common.ExecuteMemoryTable(Common.mySQL, "SELECT * FROM files WHERE venue_id = " & Common.iCurrentVenueID & _
															" AND section_id = " & Common.iCurrentSectionID & _
															" AND qorder = " & iQOrder, Null, 0)
															
	If VisitPhotos.Size > 0 Then
		If Common.MsgboxShow("Preview Pictures Taken?","Preview","Continue","","Cancel") = DialogResponse.POSITIVE Then
			iPreviewCount = 1
			PreviewNext
		End If
	End If
End Sub

Sub PreviewNext
	Dim Cols() As String
	Dim PreviewBitmap As Bitmap

	For iCount = iPreviewCount To VisitPhotos.Size
		Cols = VisitPhotos.Get(iCount-1)
		Filename = Cols(0)
		If File.Exists(Common.sTestPhotosPath,Filename) == True Then
			iPreviewCount = iCount + 1
			pnlCamera.BringToFront
			lblNext.BringToFront
			lblDelete.BringToFront
			PreviewBitmap = LoadBitmap(Common.sTestPhotosPath,Filename)
			pnlCamera.SetBackgroundImage(PreviewBitmap)
			pnlCamera.Visible = True
			lblNext.Visible = True
			lblDelete.Visible = True
			Exit
		End If
	Next
	
End Sub

Sub lblNext_Click
	lblNext.Visible = False
	lblDelete.Visible = False
	pnlCamera.Visible = False
	ShowCurrentQuestion
	PreviewNext
End Sub

Sub lblDelete_Click
	File.Delete(Common.sTestPhotosPath, Filename)	
	Common.mySQL.ExecNonQuery("DELETE FROM files WHERE filename = '" & Filename & "'")
	Common.MessageShow("Picture removed.", True)	
	Common.ForceGallery(Filename)	
	lblNext.Visible = False
	lblDelete.Visible = False
	pnlCamera.Visible = False
	ShowCurrentQuestion
	PreviewNext
End Sub

